#include <stdio.h>
#include <dos.h>
#include "p6stats.h"

#include "xmem.h"

typedef unsigned short WORD;
typedef unsigned long DWORD;


#define K 1024L
#define NUMERO (K*8)
DWORD OverHead0=0, OverHead1=0, Tiempo=0, TiempoOverHead=0;
DWORD m0;   // direcciones fsicas de 32 bits de nuestras matrices


void EscribirElemento(DWORD dir, DWORD pos, WORD valor);
WORD LeerElemento(DWORD dir,DWORD pos);
void EscribirVector(DWORD dir, DWORD zanc, DWORD pos);
void LeerVector(DWORD dir,DWORD zanc,DWORD pos);
void Vacio(DWORD dir,DWORD zanc,DWORD pos);


DWORD tam, zanc;

void limpia_cache(void){
	LeerVector(m0,1,K*K);
}

void prueba(void){
  /* esta primera vez es slo para que se cargue en la cach*/
  TSCComenzar();
  ComenzarMonitor();
  Vacio(m0,8,128); /*no importan los parametros que se le manden a esta funcion,
	ya que solo contiene las llamadas que no son del vector */
  TerminarMonitor();

  TiempoOverHead=TSCTerminar();

  TSCComenzar();
  ComenzarMonitor();
  Vacio(m0,8,128);
  TerminarMonitor();

  TiempoOverHead=TSCTerminar();
  OverHead0=MPContador0;
  OverHead1=MPContador1;


  TSCComenzar();
  ComenzarMonitor();

/*********************************************************************/
/**********  AQUI DEBE IR EL CODIGO PARA EVALUAR    ******************/

/*
#define TAM_CACHEL1_PIII   x1*K 	  debe ir en bytes
#define TAM_CACHEL2_PIII   x2*K 	  debe ir en bytes
*/

  EscribirVector(m0,zanc,(tam*K) >>1 );  /* La operacion >>1 divide por dos,
		o sea, pasa el tam de bytes a palabras */

  /* PISTA PARA CALCULAR EL NUMERO DE VIAS: HACER ESCRITURAS EN
  POSICIONES QUE SE DISTANCIEN EN MULTIPLOS DEL TAMAO DE LOS CACHES*/
/*
  EscribirVector(m0+   TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+2L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+3L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+4L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+5L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+6L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+7L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+8L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
  EscribirVector(m0+9L*TAM_CACHEL2_PIII,zanc,(tam*K) >>1 );
*/

/**********************************************************************/
  TerminarMonitor();
  Tiempo=TSCTerminar();

  MPContador0-=OverHead0;
  MPContador1-=OverHead1;
  Tiempo-=TiempoOverHead;

  printf ("Duracin: %ld\nNumero de eventos contador 0: %lu\nNumero de eventos contador 1: %lu\n", Tiempo, MPContador0, MPContador1);

}
void main (void)
{
	int ev0,ev1;
	HXMS mem_ext;  // handle a nuestro bloque de memoria en XMS devuelto por la funcin X_malloc


	/* intento reservar un pool de 8Mb de memoria XMS */
	if (!X_inicia_gestor(8192))
	{
		printf ("La CPU est en modo V8086. No puedo pasar al modo protegido.\n");
		exit(1);
	}

	/* tengo pool de memoria. De ese pool de memoria, asigno 4096Kb para mi matriz */

	mem_ext=X_malloc(4194304);
	if (mem_ext==-1)
	{
		printf ("No hay memoria para la matriz. Quedan %ld bytes\n", X_coreleft());
		exit(1);
	}

	/* Pido la direccin fsica de mi bloque de 4Mb, que es con lo que yo real-
	mente voy a trabajar. Realmente mi matriz es un vector de 2 Megas de WORD lo
	que es igual a 4Mb, por lo tanto cuando yo acceda a dicha matriz lo har
	de 2 en 2 bytes */

	m0=X_direccion(mem_ext);



  clrscr();


  printf("Dame evento 0 : ");
  scanf("%x",&ev0);
  fflush(stdin);   /* flush the input stream in case of bad input */
  printf("Dame evento 1 : ");
  scanf("%x",&ev1);
  fflush(stdin);   /* flush the input stream in case of bad input */

do{
  printf("Dame zancada en palabras -16 bits- : ");
  scanf("%ld",&zanc);
  fflush(stdin);   /* flush the input stream in case of bad input */
  }
while (zanc<1);

do{
  printf("Dame tamao en KB: ");
  scanf("%ld",&tam);
  fflush(stdin);   /* flush the input stream in case of bad input */
  }
while (tam<1);

  SelecEvento (0, (BYTE)ev0, 0, N_EVENTOS);
  SelecEvento (1, (BYTE)ev1, 0, N_EVENTOS);

  printf ("\nPrueba de los contadores\n");

  disable();


  limpia_cache();
  prueba();
  limpia_cache();
  prueba();
  limpia_cache();
  prueba();
  limpia_cache();
  prueba();

  while(!kbhit());


  enable();

  /* desasignamos la memoria XMS usada para almacenar nuestra pantalla */
  X_free(mem_ext);

  /* liberamos el handle XMS y devolvemos el pool de memoria al gestor XMS */
  X_fin_gestor();


}
