.model large

.data
mem48        db 6 dup (0)
gdt          db 8 dup (0)
             db 0FFh, 0FFh, 0, 0, 0, 92h, 0CFh, 0FFh

.code pmode32
             public C initcpu32
             public C modo_virtual

modo_virtual proc C
.386p
             smsw ax
             and ax,1
             ret
.286
modo_virtual endp

initcpu32    proc C
.386p
	     mov mem48,16
             mov eax,seg gdt
	     shl eax,4
	     mov bx,offset gdt
	     movzx ebx,bx
	     add eax,ebx
	     mov dword ptr mem48+2,eax
	     lgdt pword ptr mem48        ;Load global descriptor table address

	     mov bx,08h                  ;Load bx to point to gdt entry 1
	     push ds
	     cli                         ;Disable interrupts
	     mov eax,cr0                 ;Switch to protected mode
	     or eax,1
	     mov cr0,eax
	     jmp PROTECTION_ENABLED      ;Clear executionpipe
PROTECTION_ENABLED:
             mov gs,bx                   ;Load segment shadow-registers
	     mov fs,bx                   ;with gdt entry 1 (4GB segment limit)
	     mov es,bx
	     mov ds,bx
	     and al,0FEh                 ;Switch back to real-mode without
	     mov cr0,eax                 ;resetting the CPU
	     jmp PROTECTION_DISABLED     ;Clear executionpipe
PROTECTION_DISABLED:
             sti                         ;Enable interrupts
             xor ax,ax
             mov fs,ax
             mov gs,ax
	     pop ds
             ret
.286
initcpu32    endp

             end